Package org.eclipse.cdt.core.dom.ast

# Interface IASTTypeIdInitializerExpression

All Superinterfaces:
  `IASTExpression`, `IASTInitializerClause`, `IASTNode`

All Known Subinterfaces:
  `ICASTTypeIdInitializerExpression`

public interface IASTTypeIdInitializerExpression extends IASTExpression
Compound literal: type-id { initializer }

Since:
  5.1
Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`IASTExpression.ValueCategory`

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ASTNodeProperty`
`INITIALIZER`
`INITIALIZER` represents the relationship between an `ICASTTypeIdInitializerExpression` and `IASTInitializer`.
`static final ASTNodeProperty`
`TYPE_ID`
`TYPE_ID` represents the relationship between an `IASTTypeIdInitializerExpression` and `IASTTypeId`.

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`EMPTY_EXPRESSION_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

## Method Summary

Modifier and Type
Method
Description
`IASTTypeIdInitializerExpression`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`IASTTypeIdInitializerExpression`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.
`IASTInitializer`
`getInitializer()`
Returns the initializer for the compound literal.
`IASTTypeId`
`getTypeId()`
Returns the type id of the compound literal.
`void`
`setInitializer(IASTInitializer initializer)`
Sets the initializer, must not be called on frozen ast.
`void`
`setTypeId(IASTTypeId typeId)`
Sets the type id of the compound literal, must not be called on frozen ast.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`getExpressionType, getValueCategory, isLValue`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

## Field Details

### TYPE_ID

static final ASTNodeProperty TYPE_ID
`TYPE_ID` represents the relationship between an `IASTTypeIdInitializerExpression` and `IASTTypeId`.

### INITIALIZER

static final ASTNodeProperty INITIALIZER
`INITIALIZER` represents the relationship between an `ICASTTypeIdInitializerExpression` and `IASTInitializer`.

## Method Details

### getTypeId

IASTTypeId getTypeId()
Returns the type id of the compound literal.

### setTypeId

void setTypeId(IASTTypeId typeId)
Sets the type id of the compound literal, must not be called on frozen ast.

### getInitializer

IASTInitializer getInitializer()
Returns the initializer for the compound literal.

### setInitializer

void setInitializer(IASTInitializer initializer)
Sets the initializer, must not be called on frozen ast.

### copy

IASTTypeIdInitializerExpression copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTNode`

### copy

IASTTypeIdInitializerExpression copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.4